﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Globalization;
using System.Collections.ObjectModel;
using System.Dynamic;
using Infragistics.Windows.Helpers;

namespace Dynamic_Objects
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
            
            DataContext = new MainVM();
        }
  
    }
    public class MainVM
    {
        public MainVM()
        {
            Data = new ObservableCollection<dynamic>();

            dynamic a = new DynamicObjectClass();
            a.FirstName = "Ivan";
            a.LastName = "Ivanov";
            Data.Add(a);

            dynamic b = new DynamicObjectClass();
            b.FirstName = "Peter";
            b.LastName = "Petrov";
            
            Data.Add(b);
        }

        public ObservableCollection<dynamic> Data { get; set; }
    }

    

    public class NamesConverter : IMultiValueConverter
    {
        public object Convert(object[] values, Type targetType, object parameter, CultureInfo culture)
        {
            if (values == null)
                return DependencyProperty.UnsetValue;

            if (targetType != typeof(String))
                return DependencyProperty.UnsetValue;

            return (values[0] as String) + " " + (values[1] as String);

        }

        public object[] ConvertBack(object value, Type[] targetTypes, object parameter, CultureInfo culture)
        {
            string str = value as string;
            if (str == null)
                return null;

            if (str == "FailConvert")
            {
                return new object[] { DependencyProperty.UnsetValue, DependencyProperty.UnsetValue };
            }

            String[] values = str.Split(null);

            object[] returnValues = new object[2];
            returnValues[0] = values[0];
            returnValues[1] = values[1];

            return returnValues;
        }
    }
}
